#!/bin/sh
#\
exec wish "$0" "$@"

package require Tk
package require sqlite3
wm minsize . 640  480

proc  getdrnfile { } {
global viewname drnfile
set fopen 0
while {$fopen !=1} {
	set drnfile [tk_getOpenFile -title "Выберите файл Дракон-схемы"]
	set drnext [file extension $drnfile]
		if  {[string compare $drnext ".drn"] == 0} then {
			set fopen 1
			return $drnfile
			} else {tk_messageBox -message "Неверное расширение"}
		}
}

proc getviewname {drnfile} {
	set viewname [file rootname $drnfile].view
	file delete $viewname
	return $viewname
}

proc creatediagramlist {drnfile } {
	global diagramlist diagramidlist dia_id
	destroy .diagramselectwindow
	toplevel .diagramselectwindow
	set diagramlist {}
	set diagramidlist {}
	sqlite3 drn $drnfile
	drn eval {select diagram_id as diagram_id, name as name from diagrams} {lappend diagramlist $name; lappend diagramidlist $diagram_id}
	if {[llength $diagramlist] == 1} then {set dia_id [lindex $diagramidlist 0]; wm title . [lindex $diagramlist 0]; additems $drnfile $dia_id} else {
		wm title .diagramselectwindow "Выбор диаграммы для просмотра"
		wm resizable .diagramselectwindow 0 0
		set ::lbox [tk::listbox .diagramselectwindow.lb  -listvariable diagramlist  -width 40 -height 10]
		pack $::lbox 
		bind $::lbox <<ListboxSelect>>  {getdiaid $diagramlist $diagramidlist $drnfile}
	}
}

proc getdiaid {diagramlist diagramidlist drnfile} {
		set idx [$::lbox curselection]
		if {[llength $idx]==1} then {set dia_id [lindex $diagramidlist $idx]}
		wm title . [lindex $diagramlist $idx]
		additems $drnfile $dia_id
}
	
proc additems {drnfile dia_id} { 
		destroy .diagramselectwindow
	set viewname [getviewname $drnfile]
	file delete $viewname
	sqlite view $viewname
	view eval {PRAGMA synchronous = OFF}
		# создали в БД view таблицу элементов
	view eval {create table vitems
			(items_id integer primary key,
			branch_id,
			type text,
			text text,
			x integer,
			y integer,
			w integer,
			h integer,
			a integer,
			color text,
			text2 text)
			}
	view eval {create table diainfo (key text primary key, value text)}
	drn eval {ATTACH DATABASE $viewname AS view}
	drn eval {INSERT INTO diainfo (key, value) select info.key, info.value FROM info where key = "canvas_font" OR key = "canvas_font_size"}
	drn eval {INSERT INTO vitems (type, text, x, y, w, h, a, color, text2) 
				SELECT items.type, items.text, items.x, items.y, items.w, items.h, items.a, items.color, items.text2	
				FROM items 
				WHERE diagram_id = :dia_id}
	drn eval {DETACH DATABASE view}
	view eval {update vitems set type = "upline" WHERE w = (select max (w) from vitems where type = "horizontal") }
	view eval {update vitems set type = "bottomline" where a = (select max(a) from vitems where type = "arrow")}
	view eval {select * from vitems where type = "branch" order by x} values {lappend branchxlist $values(x)}
	set l [expr [llength $branchxlist] -1]
	for {set i 0} {$i <= $l } {incr i} {
		set currentx [lindex $branchxlist $i]
		if {$i < $l} then {set nextx [lindex $branchxlist [expr $i +1]]} else {set nextx [expr $nextx +1]}
		set branch_id [expr $i+1]
		view eval {update vitems set branch_id = :branch_id where x>=:currentx and x < :nextx}
	}
# корректируем branch_id для отдельных элементов
	view eval {select y as upline_y from vitems where type = "upline"} {set upline_y $upline_y}
	view eval {update vitems set branch_id = 0 where y < :upline_y and type != "vertical"}
	view eval {update vitems set branch_id = 0 where type = "upline" or type = "bottomline"}

	view eval {select min(y) as min_y, h as h from vitems where type = "beginend"} {set min_y [expr $min_y - $h -10]}
	view eval {select min(x) as min_x, y as y, h as h from vitems where type = "bottomline"} {set min_x [expr $min_x -10]; set max_y [expr $y + $h+10]}
	view eval {insert into diainfo (key, value) values ("min_x", :min_x)}
	view eval {insert into diainfo (key, value) values ("right_x", :min_x)}
	view eval {select x as max_x, w as w from vitems where x = (select max(x) from vitems where type = "branch")} {set max_x [expr $max_x + $w +10]}
	view eval {insert into diainfo (key, value) values ("last_branch_x", :min_x)}
	view eval {insert into diainfo (key, value) values ("last_address_x", :min_x)}
	set displaymaxx [winfo screenwidth .]
	set displaymaxy  [winfo screenheight .] 

	wm maxsize . [expr $max_x - $min_x] [expr $max_y - $min_y]

	canvas .canvas -scrollregion "$min_x $min_y $max_x $max_y" -width $displaymaxx -heigh $displaymaxy -background white
	pack .canvas -expand yes
	bind .canvas <Button-4> {.canvas yview scroll -1 units}
	bind .canvas <Button-5> {.canvas yview scroll 1 units}
	bind .canvas <Shift-Button-4> {.canvas xview scroll -1 units}
	bind .canvas <Shift-Button-5> {.canvas xview scroll 1 units}
	bind . <F3> {. configure; creatediagramlist [getdrnfile]}
	prepare_view 1
}

proc getfont { } {
	drn eval {select count (*) as isfont from info where key = "canvas_font"} {set isfont $isfont}
	if {$isfont == 0} then {font create viewfont -family Arial -size 10} else {
		drn eval {select value as fontname from info where key = "canvas_font"} {set fontname $fontname}
		drn eval {select value as fontsize from info where key = "canvas_font_size"} {set fontsize $fontsize}
		font create viewfont -family $fontname -size $fontsize
	}
	return viewfont
}

proc selectnormalsizebranch {activebranchnum} {
    set normsizebranchnumlist {}
	lappend normsizebranchnumlist $activebranchnum
	view eval {select branch_id from vitems where type = "branch" and text in (select text from vitems where branch_id= :activebranchnum and type = "address")} {lappend normsizebranchnumlist $branch_id}
	return $normsizebranchnumlist
}

# prepare_view - принимает номер активной ветки
proc prepare_view {activebranch_num} {
	global viewfont
	set space 20
	set viewfont [getfont]
	# вычисляем количество веток branch_count
	view eval {select count (*) as branch_count from vitems where type = "branch"} {set branch_count $branch_count}
	view eval {select value as x from diainfo where key = "right_x"} {set right_x $x}
	set prelast [expr $branch_count -1]
	set normsizebranchnumlist [selectnormalsizebranch $activebranch_num]
	for {set i 1} {$i <= $branch_count} {incr i} {
		set isnorm [lsearch $normsizebranchnumlist $i]
		set returnlist [draw_normsizebranch $i $right_x $space]
		set right_x [lindex  $returnlist 0]
		if {$i==1} then {set  firstx [lindex  $returnlist 3]}
		if {$i == $prelast} then {set lastaddressx [lindex  $returnlist 1]}
		set lastbranchx [lindex  $returnlist 2]
	}
	draw_zero_branch $firstx $lastaddressx $lastbranchx
}

proc draw_zero_branch {firstx lastaddressx lastbranchx} {
	view eval { select * from vitems where branch_id = 0 and  type = "horizontal"} val {draw_horizontal $firstx $val(y) $val(w)}
	view eval { select * from vitems where branch_id = 0 and  type = "beginend"} val {draw_beginend $val(text)  $firstx $val(y) $val(h) $val(w) $val(a); set shift [expr $val(x) - $firstx]}
	view eval { select * from vitems where branch_id = 0 and  type = "action"} val {set x [expr $val(x) - $shift]; draw_action $val(text)  $x $val(y) $val(h) $val(w)}
	view eval { select * from vitems where branch_id = 0 and  type = "upline"} val {set w [expr $lastbranchx-$firstx]; draw_horizontal $firstx $val(y) $w}
	view eval { select * from vitems where branch_id = 0 and  type = "bottomline"} val {set a [expr $lastaddressx-$val(x)]; set w [expr $firstx -$val(x)]; draw_bottomline $val(x) $val(y) $val(h) $w $a}
}

proc draw_normsizebranch {branch_id right_x space} {
	set lastaddressx 0
	set lastbranchx 0
	view eval {select min(x) as min_x from vitems where branch_id = :branch_id} {set min_x $min_x}
  	view eval {select max(w) as max_w from vitems where x = :min_x and branch_id = :branch_id and type != "horizontal" and type !="arrow"} {set max_w $max_w;}
  	set shift [expr $min_x - $max_w - $right_x - $space]
	set right_x [expr $min_x + $max_w - $shift]
	set firstx [expr $min_x - $shift]
	view eval { select * from vitems where branch_id =:branch_id and  type = "horizontal"} val {set x [expr $val(x)-$shift]; draw_horizontal $x $val(y) $val(w)}
	view eval { select * from vitems where branch_id =:branch_id and  type = "vertical"} val {set x [expr $val(x)-$shift]; if {$x > $right_x} then {set right_x $x}; draw_vertical $x  $val(y) $val(h)}
	view eval { select * from vitems where branch_id =:branch_id and  type = "arrow"} val {set x [expr $val(x)-$shift]; if {$x > $right_x} then {set right_x $x}; draw_arrow $x  $val(y) $val(h) $val(w) $val(a)}
    view eval { select * from vitems where branch_id =:branch_id and type = "address"} val {set x [expr $val(x)-$shift]
																																							if {$x > $lastaddressx} then {set lastaddressx $x}
																																							set x1 [expr $x + $val(w)]
																																							if {$x1 > $right_x} then {set right_x $x1}
																																							draw_address $val(text) $x $val(y) $val(h) $val(w)}
	view eval { select * from vitems where branch_id =:branch_id and type = "branch"} val {set x [expr $val(x)-$shift] 
																																							if {$x > $lastbranchx} then {set lastbranchx $x}
																																							set x1 [expr $x + $val(w)]
																																							if {$x1 > $right_x} then {set right_x $x1}
																																							draw_branch $val(text) $x $val(y) $val(h) $val(w)}
	view eval { select * from vitems where branch_id =:branch_id and type != "horizontal" and type != "vertical" and type !="arrow" and type != "address" and type != "branch"} val {set x [expr $val(x)-$shift]; set x1 [expr $x + $val(w)]; if {$x1 > $right_x} then {set right_x $x1}; draw $val(type) $val(text) $val(text2) $x $val(y) $val(h) $val(w) $val(a) $val(color)}
	return "$right_x $lastaddressx $lastbranchx $firstx"
}

proc draw_vertical {x y h} {
	set bottom [expr $y+$h]
	.canvas create line $x $y $x $bottom -fill black
}

proc draw_horizontal {x y w} {
	set right [expr $x+$w]
	.canvas create line $x $y $right $y -fill black
}
proc draw_arrow {x y h w a} {
	set left [expr $x-$w]
	.canvas create line $x $y $left $y -fill black
	set arrx [expr $left + 20]
	set arrupy [expr $y - 6]
	set arrdowny [expr $y +6]
	.canvas create polygon  $left $y $arrx $arrupy  $arrx $arrdowny -fill black
	set bottom [expr $y+$h]
	.canvas create line $x $y $x $bottom -fill black
    set leftbottom [expr $x - $a]
    .canvas create line $x $bottom $leftbottom $bottom -fill black
}

proc draw {type text text2 x y h w a color} {

	switch $type {
		beginend {draw_beginend $text $x $y $h $w $a}
		branch  {draw_branch $text $x $y $h $w} 
		address {draw_address $text $x $y $h $w}
		action {draw_action $text $x $y $h $w}		
		insertion {draw_insertion $text $x $y $h $w}	
		vertical {draw_vertical $x $y $h}
		horizontal {draw_horizontal $x $y $w}
		arrow {draw_arrow $x $y $h $w $a}
		if 	{draw_if $text  $x $y $h $w $a}
		commentin {draw_commentin $text  $x $y $h $w $a}
		shelf {draw_shelf $text $text2 $x $y $h $w $a}
		upline  {draw_horizontal $x $y $h $w}
		bottomline {draw_bottomline $x $y $h $w $a}
		select {draw_select $text $x $y $h $w}
		case {draw_case $text $x $y $h $w}
		default {draw_action "Не могу нарисовать" $x $y $h $w}
	}	
}

proc draw_case {t x y h w} {
	set h2 [ expr { $h / 1.5 } ]
	set middle [ expr { $y + $h - $h2 } ]
	set left [expr $x-$w]
	set right [expr $x+$w]
	set top [expr $y-$h]
	set bottom [expr $y+$h]
	set texty [expr $top + ($middle - $top)/2]
    .canvas create polygon $left $middle  $left $top  $right $top $right $middle $x $bottom $left $middle -fill white -outline black
    .canvas create line $left $middle $right $middle -fill black
    .canvas create text $x $texty -text $t -font viewfont
 } 
    
    
proc draw_select {t x y h w} {
set x0 [expr $x - $w]
set x1 [expr $x + $w]
set ytop [expr $y - $h]
set x2 [expr $x +$w - $h/2.0]
set ybottom [expr $y +$h]
set x3 [expr $x0 - $h/2.0]
set lup {list $x $ytop}
set rup {list $x1 $ytop}
set rdwn {list $x2 $ybottom}
set ldwn {list $x3 $ybottom}
.canvas create polygon $x0 $ytop $x1 $ytop $x2 $ybottom $x3 $ybottom  -fill white -outline black
.canvas create text $x $y -text $t -font viewfont
}

proc draw_action {t x y h w} {
	set left [expr $x-$w]
	set right [expr $x+$w]
	set top [expr $y-$h]
	set bottom [expr $y+$h]
	.canvas create rectangle $left $top $right $bottom  -fill white -outline black
	.canvas create text $x $y -text $t -font viewfont
}

proc draw_shelf {t t2 x y h w a} {
	set top [ expr { $y - $h } ]
	set left [ expr { $x - $w } ]
	set right [ expr { $x + $w } ]
	set bottom [ expr { $y + $h } ]
	set m [ expr { $top + $a } ]
	set h1 [ expr { $h - $a / 2 } ]
	set h2 [ expr { $a / 2 } ]
	set y2 [ expr { $top + $h2 } ]
	set y1 [ expr { $m + $h1 } ]
	.canvas create rectangle $left $top $right $bottom  -fill white -outline black
	.canvas create line $left $m $right $m  -fill black
	.canvas create text $x $y1 -text $t -font viewfont
	.canvas create text $x $y2 -text $t2 -font viewfont
}

proc draw_commentin {t x y h w a} {
	set left [expr $x-$w]
	set right [expr $x+$w]
	set top [expr $y-$h]
	set bottom [expr $y+$h]
	set r 20
	set lt1 [expr $left + 6]	
	set t1 	[expr $top +6 + $r]
	set lt2 [expr $left +6 + $r]
	set t2 	[expr $top + 6]
	set r1 [expr $right - 6 - $r]	
	set r2 [expr $right - 6 ]
	set b1 [expr $bottom - 6 - $r]
	set b2 [expr $bottom - 6]
	.canvas create rectangle $left $top $right $bottom  -fill gray -outline black
	# нужно будет заранее вычислить координаты, всё побыстрее будет
	.canvas create oval [expr $left + 6] [expr $top +6] [expr $left +6 + $r*2] [expr $top +6 + $r*2] -fill white -outline black
	.canvas create oval [expr $right - 6] [expr $top +6] [expr $right -6-$r*2] [expr $top +6+ $r*2] -fill white -outline black
	.canvas create oval [expr $right - 6] [expr $bottom - 6] [expr $right -6-$r*2] [expr $bottom -6-$r*2] -fill white -outline black
	.canvas create oval [expr $left + 6] [expr $bottom - 6] [expr $left +6+$r*2] [expr $bottom -6-$r*2] -fill white -outline black
	.canvas create polygon $lt1 $t1  $lt2 $t2 $r1 $t2 $r2 $t1 $r2	$b1 $r1 $b2 $lt2 $b2 $lt1 $b1  -fill white -outline white
	.canvas create line  $lt1 $t1 $lt1 $b1
	.canvas create line  $lt2 $t2 $r1 $t2
	.canvas create line  $r2 $t1 $r2 $b1
	.canvas create line  $r1 $b2 $lt2 $b2
	.canvas create text $x $y -text $t -font viewfont
}
proc draw_beginend {t x y h w a} {
	set left [expr $x-$w+$h]
	set right [expr $x+$w-$h]
	set top [expr $y-$h]
	set bottom [expr $y+$h]
	set circle1left [expr $x-$w]
	set circle1right [expr $circle1left+2*$h]
	set circle2left [expr $x + $w]
	set circle2right [expr $circle2left - 2*$h]
	.canvas create oval $circle1left $top $circle1right $bottom -fill white
	.canvas create oval $circle2left $top $circle2right $bottom -fill white
	.canvas create rectangle $left $top $right $bottom -fill white -outline white
	.canvas create line $left $top $right $top -fill black
	.canvas create line $left $bottom $right $bottom -fill black
	.canvas create text $x $y -text $t -font viewfont
}	

proc draw_branch {t x y h w} {
	set h2 [ expr { $h / 1.5 } ]
	set middle [ expr { $y + $h - $h2 } ]
	set left [expr $x-$w]
	set right [expr $x+$w]
	set top [expr $y-$h]
	set bottom [expr $y+$h]
	set texty [expr $top + ($middle - $top)/2]
    .canvas create polygon $left $middle  $left $top  $right $top  $right $middle  $x $bottom  $left $middle -fill white -outline black
    .canvas create text $x $texty -text $t -font viewfont
}

proc  draw_address {t x y h w} {
	set h2 [ expr { $h / 1.5 } ]
	set middle [ expr { $y - $h + $h2 } ]
	set left [ expr { $x - $w } ]
	set right [ expr { $x + $w } ]
	set top [ expr { $y - $h } ]
	set bottom [ expr { $y + $h } ]
	set coords [ list $left $middle  $x $top  $right $middle  $right $bottom $left $bottom  $left $middle ]
   .canvas create polygon $left $middle  $x $top  $right $middle  $right $bottom $left $bottom  $left $middle -fill white -outline black
   .canvas create text $x $y -text $t -font viewfont
}

proc draw_insertion {t x y h w} {
	set x0 [ expr { $x - $w + 5 }]
	set left [ expr { $x - $w }]
	set right [ expr { $x + $w }]
	set x1 [ expr { $x + $w - 5 } ]
	set top [ expr { $y - $h } ]
	set bottom [ expr { $y + $h } ]
	.canvas create rectangle $left $top $right $bottom -fill white
	.canvas create line  $x0 $top $x0 $bottom
	.canvas create line  $x1 $top $x1 $bottom
	.canvas create text $x $y -text $t -font viewfont
}

proc draw_if {t x y h w a} {
set x0 [ expr { $x - $w } ]
	set x1 [ expr { $x0 + $h } ]
	if { $x1 > $x } { set x1 $x }
	set x3 [ expr { $x + $w } ]
	set x2 [ expr { $x3 - $h } ]
	if { $x2 < $x } { set x2 $x }
	set top [ expr { $y - $h } ]
	set bottom [ expr { $y + $h } ]
	set lineright [expr $x3+$a]
	.canvas create polygon $x0 $y  $x1 $top  $x2 $top  $x3 $y  $x2 $bottom  $x1 $bottom $x0 $y -fill white -outline black
	.canvas create line $x3 $y $lineright $y
	.canvas create text $x $y -text $t -font viewfont
}

proc draw_bottomline { x y h w a} {
	set x0 [expr $x+$w]
	.canvas create line $x $y $x0 $y
	set arrx [expr $x0 - 20]
	set arrupy [expr $y - 6]
	set arrdowny [expr $y +6]
	.canvas create polygon  $x0 $y $arrx $arrupy  $arrx $arrdowny -fill black
	set y0  [expr $y + $h]
	.canvas create line $x $y $x $y0
	set xend  [expr $x+$a]
	.canvas create line $x $y0 $xend $y0
}
creatediagramlist [getdrnfile]	

